package com.redenchilada.scootanet.statusnet;

import java.util.LinkedList;
import org.json.*;

import com.redenchilada.scootanet.lib.BBCode;

import android.text.SpannableString;

import java.util.HashMap;

public class Notice
{
	public String name, iconPath;
	public SpannableString notice;
	public int id, inReplyTo;
	
	public Notice(String notice, String name, int id, int inReplyTo, String iconPath)
	{
		this.name = name;
		this.id = id;
		this.inReplyTo = inReplyTo;
		this.iconPath = iconPath;
		this.notice = BBCode.processNotice(notice);
	}
	
	public String toString()
	{
		return "[" + id + "] <" + name + "> " + notice.toString();
	}
	
	//Static methods
	
	//These are a mess, you were probably tired when you wrote them. Consider rewriting or at least error-proofing.
	
	private static HashMap<Integer, Notice> noticeBank = new HashMap<Integer, Notice>();
	private static LinkedList<Integer> noticeCache = new LinkedList<Integer>();
	
	public static Notice get(int id)
	{
		if(!noticeCache.contains(id))
			parseNotice(getNoticeJSON(Get.loadNotice(id)));
			
		return noticeBank.get(id);
	}
	
	public static JSONObject getNoticeJSON(String input)
	{
		return null;
	}
	
	public static void addToBank(Notice honk)
	{
		Integer eep = new Integer(honk.id);
		
		if(!noticeCache.contains(eep))
		{
			noticeBank.put(eep, honk);
			noticeCache.add(eep);
			if(noticeCache.size() > 100)
			{
				noticeBank.remove(noticeCache.pop());
			}
		}
	}
	
	public static int[] parseNotices(String input)
	{
		if(!input.contains("["))
			return null;
		
		LinkedList<Integer> scooters = new LinkedList<Integer>();
		
		JSONArray temp = null;
		try
		{
			temp = new JSONArray(input.substring(input.indexOf("[")));
			for(int w = 0; w < temp.length(); w++)
				scooters.add(parseNotice(temp.optJSONObject(w)));
		}
		catch(JSONException e)
		{
			e.printStackTrace();
			return null;
		}

		int[] out = new int[scooters.size()];
		
		for(int i = 0; i < out.length; i++)
			out[i] = scooters.pop();
		
		return out;
	}
	
	public static Integer parseNotice(JSONObject beep)
	{
		if(beep == null)
			return null;
		
		if(beep.isNull("retweeted_status"))
		{
			String notice = beep.optString("statusnet_html", "improperly-loaded notices make me cry ;~;");
			String name = beep.optJSONObject("user").optString("screen_name", "nopony");
			String iconPath = beep.optJSONObject("user").optString("profile_image_url", "none");
			int id = beep.optInt("id", 0);
			int inReplyTo = beep.optInt("in_reply_to_status_id", 0);
			
			if(!noticeBank.containsKey(new Integer(id)))
				addToBank(new Notice(notice, name, id, inReplyTo, iconPath));
			
			return id;
		}
		else
		{
			return 0;
		}
	}
	/*
	public static LinkedList<Notice> parseNotices(String input)
	{		
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		
		Document dom = null;
		
		try
		{

			//Using factory get an instance of document builder
			DocumentBuilder db = dbf.newDocumentBuilder();
			
			InputSource is = new InputSource();
		    is.setCharacterStream(new StringReader(input.substring(input.indexOf("<"))));

			//parse using builder to get DOM representation of the XML file
			dom = db.parse(is);


		}
		catch(ParserConfigurationException pce)
		{
			pce.printStackTrace();
		}
		catch(SAXException se)
		{
			se.printStackTrace();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		
		//get the root element
		Element docEle = dom.getDocumentElement();

		LinkedList<Notice> notices = new LinkedList<Notice>();
		
		//get a nodelist of elements
		NodeList nl = docEle.getElementsByTagName("entry");
		
		if(nl != null && nl.getLength() > 0) {
			for(int i = 0 ; i < nl.getLength();i++) {

				//get the employee element
				Element el = (Element)nl.item(i);

				//get the Employee object
				Notice e = getNotice(el);

				//add it to list
				notices.add(e);
			}
		}
		
		return notices;

	}
	
	private static Notice getNotice(Element pig)
	{
		String notice = pig.getElementsByTagName("title").item(0).getNodeValue();
		String idTemp = pig.getElementsByTagName("id").item(0).getNodeValue();
		int id = Integer.parseInt(idTemp.substring(idTemp.indexOf("notice/")+7));
		int conversation = Integer.parseInt(pig.getElementsByTagName("source").item(0).getPreviousSibling()
			.getNodeValue().split("conversation\\/")[1]);
		NodeList temp = pig.getElementsByTagName("author").item(0).getChildNodes();
		String name = "not found", iconPath = "none";
		
		for(int i = 0; i < temp.getLength(); i++)
		{
			Node asd = temp.item(i);
			if(asd.getNodeName().equals("name"))
				name = asd.getNodeValue();
			if(asd.getNodeName().equals("icon"))
				iconPath = asd.getNodeValue();
		}
		
		return new Notice(notice, name, id, conversation, iconPath);
	}
	*/
}
