package com.redenchilada.scootanet.widgets;

import android.content.Context;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.widget.EditText;
import android.widget.TextView;
import com.redenchilada.scootanet.statusnet.Post;


public class NoticeBox extends EditText
{
	public int inReplyTo;
	
    public NoticeBox(Context context, AttributeSet attrs)
    {
        super(context, attrs);
        inReplyTo = 0;
    }

    public boolean onKeyDown(int keyCode, KeyEvent event)
    {
    	if(keyCode == KeyEvent.KEYCODE_ENTER && event.getAction() == KeyEvent.ACTION_DOWN)
    	{
    		if(inReplyTo == 0)
    			Post.postNewNotice(getText().toString());
    		else
    			Post.postReply(getText().toString(), inReplyTo);
    		setText("",TextView.BufferType.EDITABLE);
    		inReplyTo = 0;
    		return true;
    	}
    	else
    		return super.onKeyDown(keyCode, event);
    }
}
